<template>
  <span class="ModalCardEdit">
    <b-button @click="showModal" variant="outline-info" class='ml-3' size="sm"><font-awesome-icon icon="pen" /></b-button>

    <b-modal :ref="'m-card-edit-' + card._id" centered :title="card.title">

      <h6>
        Card name
      </h6>

      <b-form-input v-model="cardName" placeholder="Change card title"></b-form-input>
      <br/><br/>

      <h6>
        Description
        <b-button @click="editDescription" v-if="!editingDesc" variant="outline-info" class='ml-3' size="sm"><font-awesome-icon icon="pen" /></b-button>
      </h6>

      <div v-if="!editingDesc"> {{card.description}} </div>
      <b-form-textarea v-if="editingDesc" v-model="description" rows="4" placeholder="Card description"></b-form-textarea>

      <br/><br/>

      <h6>
        Move to 
        <br/><br/>
        <b-form-select v-model="moveTo" :options="optionsMoveTo" size="sm"></b-form-select>
      </h6>

      <template #modal-footer>
        <div class="w-100">
          <b-button 
            @click="deleteCard" 
            variant="danger" 
            class='float-right ml-2'>
              <font-awesome-icon icon="trash-alt" /> Delete card
          </b-button>
          <b-button
            variant="success"
            class="float-right ml-2"
            @click="$bvModal.hide('m-card-edit-' + card._id); updateCard();"
          >
            Save
          </b-button>

        </div>
      </template>
    </b-modal>

  </span>
</template>

<script>
import axios from 'axios';

export default {
  name: 'ModalCardEdit',
  props: ['card', 'board', 'list'],
  data(){
    return {
      cardName: this.card.title,
      description: this.card.description,
      editingDesc: false,
      moveTo: null,
      optionsMoveTo: []
    }
  },
  methods:{
    editDescription(){
      this.editingDesc = true
    },
    showModal() {
      this.$refs['m-card-edit-' + this.card._id].show()
    },
    deleteCard(){

      axios.delete(`${process.env.VUE_APP_URL}/cards/${this.card._id}`)
      .then(response => {
          console.log(response.data)
          window.location.reload(false);
      })
      .catch(error => alert("error " + error))

    },
    updateCard(){
      let card = {
        title: this.cardName,
        description: this.description
      }

      if(this.moveTo){

        // post on selected list
        axios.post(`${process.env.VUE_APP_URL}/cards/${this.moveTo}`, card)
        .then(response => {
            console.log(response.data)
            this.cardName = ''
            this.description = ''

            // delete from current list
            axios.delete(`${process.env.VUE_APP_URL}/cards/${this.card._id}`)
            .then(response => {
                console.log(response.data)

                // refresh page
                window.location.reload(false);
            })
            .catch(error => alert("error " + error))
        })
        .catch(error => alert("error " + error))


      } else {
        axios.put(`${process.env.VUE_APP_URL}/cards/${this.card._id}`, card)
        .then(response => {
            console.log(response.data)
            this.cardName = ''
            this.description = ''
            window.location.reload(false);
        })
        .catch(error => alert("error " + error))
      }

      this.cardName = ''
      this.description = ''
    }
  },
  mounted () {

    axios.get(`${process.env.VUE_APP_URL}/lists/board/${this.board._id}`)
      .then(response => {
          this.optionsMoveTo = response.data
          .filter(Element => Element._id != this.list._id)
          .map(Element => {
            return { text:Element.name, value: Element._id}
          })
      })
      .catch(error => alert("error " + error))
  }
}
</script>


<style scoped>
#ModalCardEdit{
}
</style>
